import numpy as np
import matplotlib.pyplot as plt
plt.close('all')

Ca=0.1
Cb=0.1
Va=10e-3

#Titrage acide fort / base forte
pHe=7

def pHavant(Vb):
    return -np.log10((Ca*Va-Cb*Vb)/(Va+Vb))

def pHapres(Vb):
    return 14+np.log10((Cb*Vb-Ca*Va)/(Va+Vb))

V=np.linspace(0,20e-3,100)
pH=np.zeros(len(V))


i=0
pHi=pHavant(0)
while pHi<pHe:
    pH[i]=pHavant(V[i])
    i+=1
    pHi=pHavant(V[i])

print(i)
    
for k in range(i,len(V)):
    pH[k]=pHapres(V[k])
    
dpH=np.zeros(len(V)-2)
for i in range(1,len(dpH)-1):
    dpH[i]=(pH[i+1]-pH[i-1])/(V[i+1]-V[i-1])

plt.figure(1) 
plt.plot(V,pH)
plt.xlabel('Volume de soude versé (en L)')
plt.ylabel('pH')
plt.title('Titrage acide fort / base forte')

plt.figure(2)
plt.plot(V[1:-1],dpH)
plt.xlabel('Volume de soude versé (en L)')
plt.ylabel('$\dfrac{dpH}{dV_b}$')
plt.title('Titrage acide fort / base forte')

plt.show()

def posmaxi(liste):
    pos=0
    m=liste[0]
    for i in range(len(liste)):
        if liste[i]>m:
            m=liste[i]
            pos=i
    return pos

print('VbE=',V[posmaxi(dpH)].round(3),'L')

#Titrage acide faible / base forte

pKa=4.8

def pHavantfaible(Vb):
    return pKa + np.log10(Cb*Vb/(Ca*Va-Cb*Vb))

V=np.linspace(0,20e-3,100)
pH=np.zeros(len(V))


i=0
pHi=pHavant(0)
while pHi<pHe:
    pH[i]=pHavantfaible(V[i])
    i+=1
    pHi=pHavantfaible(V[i])

print(i)
    
for k in range(i,len(V)):
    pH[k]=pHapres(V[k])
    
plt.figure(3) 
plt.plot(V,pH)
plt.xlabel('Volume de soude versé (en L)')
plt.ylabel('pH')
plt.title('Titrage acide faible / base forte')
plt.show()

print('pKa=',pH[posmaxi(dpH)//2].round(2))